/****************************************************************************/
/**                                                                        **/
/**                                Example.c                               **/
/**                                                                        **/
/** Example program for INT.c                                              **/
/**                                                                        **/
/** Copyright (C) Marcel de Kogel 1996                                     **/
/**     You are not allowed to distribute this software commercially       **/
/**     Please, notify me, if you make any changes to this file            **/
/****************************************************************************/

#include "INT.h"

#include <stdio.h>
#include <pc.h>
#include <crt0.h>

/* DJGPP startup flags */
int _crt0_startup_flags = _CRT0_FLAG_NONMOVE_SBRK | _CRT0_FLAG_LOCK_MEMORY;

static int chain_to_old_handler;
static volatile int currkey;

static int keyb_interrupt (void)
{
 unsigned code;
 static int extkey;
 code=inportb (0x60);             /* get scancode                           */
 if (code<0xE0)                   /* ignore codes >0xE0                     */
 {
  if (code<0x80)                  /* key is pressed                         */
  {
   if (extkey)
    currkey=code+128;
   else
    currkey=code;
  }
  extkey=0;
 }
 else
  if (code==0xE0)
   extkey=1;
 if (chain_to_old_handler) return 1;
 code=inportb (0x61);             /* acknowledge interrupt                  */
 outportb (0x61,code | 0x80);
 outportb (0x61,code);
 outportb (0x20,0x20);
 return 0;                        /* Do not chain to old handler            */
}

static _go32_dpmi_seginfo keybirq;

static void Keyb_Init (void)      /* get old handler and install our own    */
{
 keybirq.pm_offset=(int)keyb_interrupt;
 keybirq.pm_selector=_go32_my_cs();
 SetInt (9,&keybirq);
}

static void Keyb_Reset (void)     /* install the old handler                */
{
 ResetInt (9,&keybirq);
}

int main (void)
{
 char buffer[256];
 printf ("Setting interrupt vector... ");
 fflush (stdout);
 chain_to_old_handler=0;
 Keyb_Init ();
 printf ("OK\nPlease press ESC... ");
 fflush (stdout);
 while (currkey!=1);
 printf ("OK\nChaining to old interrupt handler... ");
 fflush (stdout);
 chain_to_old_handler=1;
 printf ("OK\nPlease type some message... ");
 fflush (stdout);
 fgets (buffer,256,stdin);
 printf ("Resetting interrupt... ");
 Keyb_Reset ();
 printf ("OK\nYou typed %s\n",buffer);
 return 0;
}

